#include "stm32f4xx.h"
#include <stdio.h>

#include "ws2812_stm32f4.h"
#include "bin_clock.h"
#include "delay.h"


int main(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	SystemInit();
	SystemCoreClockUpdate();
	SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK);
	init_systick();

	// debug and time measurement
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);

  	ws2812_init();
  	ws2812_test_pattern();
	delay_ms(500);

  	if(bin_clock_init(RTC_HourFormat_24) != 0)
  	{
  		while(1);
  	}
  	if(set_default_time() != 0)
  	{
  		while(1);
  	}

  	while(1)
  	{
  		GPIO_ToggleBits(GPIOB,GPIO_Pin_2);
		ws2812_update_leds();
  		GPIO_ToggleBits(GPIOB,GPIO_Pin_2);

  		delay_ms(100);
  	}
}


#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif
